/*
 * IDLflex -- A flexible, generic code generator for CORBA IDL
 *
 * Copyright (C) 2001  Franz J. Hauck, AspectIX Research Team
 *                     University of Erlangen-Nuernberg, Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License.
 * The full text of the license can be found in the LICENSE.txt file.
 *
 * $Id: Debug.java,v 1.2 2001/06/15 11:12:09 fzhauck Exp $
 */

package org.aspectix.IDLflex;

/** Class to support debug output messages.
 */
public final class Debug
{
    // Debug levels
    public static final int QUIET= 0;
    public static final int IMPORTANT= 1;
    public static final int INFORMATION= 2;
    public static final int TRACE= 3;

    // Debug sections
    public static final int IRO= 0;
    public static final int MAX_SECTIONS= 1;		// highest value +1

    /**	Section names.
     */
    private static String[] sections= new String[] { "IRO" };

    /**	Variable to hold debug output configuration
     */
    private static int[] debugConfig= { QUIET };
    

    /**	Print debug message.
     */
    public static void print( String msg, int level, int section )
    {
	if( debugConfig[section] >= level )
	{
	    System.err.println( "IDLflex(" + level + "/" +sections[section] +
	    			"): " + msg );
	}
    }
}
