/*
 * IDLflex -- A flexible, generic code generator for CORBA IDL
 *
 * Copyright (C) 2000  Hans Reiser, AspectIX Research Team
 *                     University of Erlangen-Nuernberg, Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License.
 * The full text of the license can be found in the LICENSE.txt file.
 *
 * $Id: XMLparser.java,v 1.2 2000/12/15 15:32:27 fzhauck Exp $
 */

package org.aspectix.IDLflex;

import org.w3c.dom.Element;

/** This is the common interface for the implementation classes to access
 *  the XML library. Currently, IDLflexMain has to be modified to 
 *  specify which implementation class has to be used.
 */
public interface XMLparser {
    /** read in the specified XML specification, parse it, and return
     *  the root element of the document. Parsing errors cause a
     *  SAXParseException.
     */
    Element parse(String xmlFile) throws Exception; 
}
